
#include "game.h"
#include "globals.h"
#include "input.h"
#include "sound.h"

static void game_update_anim_carlos_fell_helper(int delta) {
	if (g_game.player_state.dead_flag) {
		return;
	}
	g_game.bounding_box_y1 = 0;
	g_game.bounding_box_x1 = 0;
	g_game.bounding_box_y2 = _screen_h;
	g_game.bounding_box_x2 = _screen_w;
	for (object_state_t *os = g_game.objects_list_cur; os <= g_game.objects_list_last; ++os) {
		if (os->displayed == 2 && (os->unk26 & 1) != 0) {
			anim_data_t *ad = os->anim_data1_ptr;
			if (os->pos_y + ad->bounding_box_y2 < g_game.bounding_box_y1) {
				continue;
			}
			if (os->pos_y + ad->bounding_box_y1 > g_game.bounding_box_y2) {
				continue;
			}
			if (os->pos_x + ad->bounding_box_x2 < g_game.bounding_box_x1) {
				continue;
			}
			if (os->pos_x + ad->bounding_box_x1 > g_game.bounding_box_x2) {
				continue;
			}
			if (ad->lifes == 0) {
				continue;
			}
			if (g_game.monster_fight_flag != 0 && os->life < 50) {
				continue;
			}
			os->transparent_flag = 0xFF;
			os->life -= delta;
			if (os->life >= 0) {
				continue;
			}
			if (ad->colliding_opcode == 10) {
				game_change_decor_tile_map_line(os, ad);
			}
//			word_18447 = 0;
			g_game.cycle_score -= ad->score;
			if ((ad->unk4 & 8) == 0) {
//				sub_906F();
			}
			if (os->anim_data3_ptr != 0) {
				os->displayed = (os->visible != 0) ? 1 : 0;
			} else {
				if (os->visible == 0) {
					os->anim_data2_ptr = 0;
				}
				os->transparent_flag = 0;
				ad = game_init_object_from_anim3(os, ad);
				game_play_anim_data_sfx(ad);
			}
		}
	}
}

static void game_update_anim_carlos_fell(int delta) {
	if (g_game.carlos_direction != 0) {
		return;
	}
	if ((inp_direction_mask & GAME_DIR_HORIZ) == 0 || (inp_direction_mask & GAME_DIR_DOWN) == 0) {
		game_shake_screen();
		if (0) {
			game_update_anim_carlos_fell_helper(delta);
		}
		snd_play_sfx(SND_SAMPLE_20);
	}
}

static void game_update_carlos_object_helper_default() {
	int offset, nicky_pos_x, nicky_pos_y, r;
	int _bp = 0;
	int _dx;

	if (g_game.carlos_direction != 0 && g_game.player_state.unk1 == 2) {
		g_game.player_state.unk1 = 0;
	}
	if (g_game.moving_decor_flag != 0) {
		g_game.player_state.decor_ref_flag0 |= 1;
		goto loc_2B99;
	}
	if (g_game.player_state.unk1 == 2) { /* jumping */
		_bp = (int16_t)g_game.player_state.move_offsets_data_ptr[0];
		if (_bp >= 0) {
			if (_bp == 0x7777) {
				_bp = (g_game.cycle_counter != 0) ? 5 : 4;
			} else {
				g_game.player_state.hdir_flags |= 4;
				g_game.player_state.move_offsets_data_ptr++;
			}
			g_game.carlos_offset_dy += _bp;
		} else {
			/* jumping */
			g_game.player_state.move_offsets_data_ptr++;
			g_game.decor_state.scroll_inc = _bp;
			g_game.player_state.hdir_flags &= ~4;
			g_game.player_state.pos_y += _bp;
			nicky_pos_x = g_game.player_state.pos_x + 16 + g_game.player_state.pos_dx_2;
			nicky_pos_y = g_game.player_state.pos_y + 4 + g_game.player_state.pos_dy_2;
			if (g_game.monster_fight_flag != 0) {
				const int y = g_game.player_state.pos_y + g_game.player_state.pos_dy_2;
				if (y <= -24) {
					g_game.player_state.hdir_flags |= 4;
					g_game.player_state.move_offsets_data_ptr = (const uint16_t *)&move_data[16];
				}
			} else {
				offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y);
				g_game.player_state.decor_ref_flag0 &= ~2;
				game_set_decor_tile_flags4_3_2_0(2, offset);
				offset = game_get_nicky_offset(nicky_pos_x + g_game.player_state.pos_dx_1, nicky_pos_y);
				game_set_decor_tile_flags4_3_2_0(2, offset);
				if (g_game.player_state.decor_ref_flag0 & 2) {
					g_game.player_state.hdir_flags |= 4;
					g_game.player_state.move_offsets_data_ptr = (const uint16_t *)&move_data[16];
				}
			}
			g_game.player_state.hdir_flags &= 0x8D;
			if (g_game.player_state.hdir_flags & 8) {
				return;
			}
			if (g_game.player_state.hdir_flags & 1) {
				g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[23];
			} else {
				g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[24];
			}
			return;
		}
	}
// 28C3
	g_game.decor_state.scroll_inc = _bp;
	nicky_pos_x = g_game.player_state.pos_x + 24 + g_game.player_state.pos_dx_2;
	g_game.player_state.pos_y += _bp;
	nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_2; /* nicky_pos_y */
	if (nicky_pos_y > 0 && nicky_pos_y + g_game.player_state.dim_h - GAME_ANIM_NICKY_DY < _screen_h) {
		nicky_pos_y += g_game.player_state.dim_h - GAME_ANIM_NICKY_DY;
		offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y);
		if ((r = game_get_decor_tile_flag7(offset)) == 0) {
			nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_2 + g_game.player_state.dim_h;
			if ((r = game_get_decor_tile_flag7(game_get_nicky_offset(nicky_pos_x, nicky_pos_y))) != 0) {
				g_game.test_object_bounding_box_offset = 0;
			} else {
				goto loc_2A03;
			}
		} else {
			g_game.test_object_bounding_box_offset = -GAME_ANIM_NICKY_DY;
		}
		const int _cx = g_game.carlos_offset_dy >> 4;
		const int _ax = g_game.carlos_offset_dy;
		g_game.carlos_offset_dy = 0;
		if (_ax >= 70) {
			game_update_anim_carlos_fell(_cx);
		} else if ((inp_direction_mask & 8) != 0) {
			game_update_anim_carlos_fell(2 + g_game.cycle_counter);
		}
		if ((r & 1) == 0) { /* left */
			int _cx = (g_game.player_state.pos_y + g_game.test_object_bounding_box_offset + g_game.player_state.pos_dy_2 + g_game.player_state.dim_h) & ~15;
			_cx -= g_game.player_state.dim_h;
			_cx -= g_game.player_state.pos_dy_2;
			nicky_pos_x &= 15;
			_cx += nicky_pos_x;
			g_game.player_state.pos_y = _cx;
			g_game.carlos_direction = -1;
			goto loc_2BAA;
		} else { /* right */
			int _cx = (g_game.player_state.pos_y + g_game.test_object_bounding_box_offset + g_game.player_state.pos_dy_2 + g_game.player_state.dim_h) & ~15;
			_cx -= g_game.player_state.dim_h;
			_cx -= g_game.player_state.pos_dy_2;
			_cx += 16;
			nicky_pos_x &= 15;
			_cx -= nicky_pos_x;
			g_game.player_state.pos_y = _cx;
			g_game.carlos_direction = 1;
			goto loc_2BAA;
		}
loc_2A03:
		_dx = g_game.player_state.pos_y + g_game.player_state.pos_dy_2;
		if (_dx > 0 && _dx + g_game.player_state.dim_h < _screen_h) {
			g_game.player_state.decor_ref_flag4 = 0;
			nicky_pos_x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2 + 16;
			nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_2 + g_game.player_state.dim_h;
			offset = game_get_nicky_offset(nicky_pos_x + 4, nicky_pos_y - 16);
			game_set_decor_tile_flags4_3_2_0(1, offset);
			g_game.player_state.decor_ref_flag0 = 0;
			g_game.player_state.decor_ref_flag3 = 0;
			offset = game_get_nicky_offset(nicky_pos_x + 4, nicky_pos_y);
			game_set_decor_tile_flags4_3_2_0(1, offset);
			offset = game_get_nicky_offset(nicky_pos_x + g_game.player_state.pos_dx_1, nicky_pos_y);
			if ((game_set_decor_tile_flags4_3_2_0(1, offset) & 0x40) != 0 && (g_game.player_state.hdir_flags & 4) == 0) {
				g_game.player_state.next_tilemap_offset = offset;
//				word_1839B = _screen_cdg_tile_map_w2;
//				word_1839D = _screen_cdg_unk2;
			}
//loc_2ABE:
			if (g_game.player_state.decor_ref_flag4 != 0 && g_game.carlos_bullmode_flag == 0) {
				++g_game.player_state.colliding;
			}
//loc_2ACF:
			if (g_game.player_state.decor_ref_flag3 >= 1) {
				goto loc_2B99;
			}
			if ((g_game.player_state.decor_ref_flag0 & 1) == 0) {
				if (g_game.player_state.decor_ref_flag3 != 1) {
					goto loc_2B4C;
				}
				goto loc_2BAA;
			}
			if ((g_game.player_state.decor_ref_flag0 & 0xC) == 0) {
				int y = g_game.player_state.pos_y + g_game.player_state.pos_dy_2 + g_game.player_state.dim_h;
				y &= 15;
				if (y > _bp) {
					goto loc_2B4C;
				}
			}
			int _bx = (g_game.player_state.pos_y + g_game.player_state.pos_dy_2 + g_game.player_state.dim_h) & ~15;
			_bx -= g_game.player_state.dim_h;
			int _cx = g_game.carlos_offset_dy >> 4;
			int _ax = g_game.carlos_offset_dy;
			g_game.carlos_offset_dy = 0;
			_bx -= g_game.player_state.pos_dy_2;
			if (_ax < 70) {
				if (_bx == g_game.player_state.pos_y) {
					goto loc_2BAA;
				}
				g_game.player_state.pos_y = _bx;
				if ((inp_direction_mask & 8) == 0) {
					_cx = 2 + g_game.cycle_counter;
				}
			}
			g_game.player_state.pos_y = _bx;
			game_update_anim_carlos_fell(_cx);
			goto loc_2BAA;
		}
	}
	/* falling */
loc_2B4C:
	g_game.player_state.hdir_flags &= 0x8D;
	if ((g_game.player_state.hdir_flags & 8) == 0) {
		if (g_game.player_state.hdir_flags & 1) {
			g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[23];
		} else {
			g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[24];
		}
		if (g_game.player_state.unk1 != 2) {
			g_game.player_state.unk1 = 2;
			g_game.player_state.move_offsets_data_ptr = (const uint16_t *)&move_data[16];
			g_game.player_state.hdir_flags |= 4;
		}
	}
	if ((inp_direction_mask & GAME_DIR_HORIZ) == 0 && (g_game.player_state.move_offsets_data_ptr[0] & 0x8000) == 0) {
		g_game.player_state.anim_frame_ptr += 2;
	}
	return;
loc_2B99:
	if ((inp_direction_mask & GAME_DIR_VERT) && (g_game.player_state.hdir_flags & 0x30)) {
		/* deplacement sur l'escalier */
		goto loc_2D03;
	}
loc_2BAA:
	g_game.player_state.unk1 = 1;
	g_game.player_state.hdir_flags &= ~4;
	if (g_game.player_state.hdir_flags & 1) {
		if (inp_direction_mask & GAME_DIR_DOWN) {
			/* accroupi gauche */
			if ((g_game.player_state.hdir_flags & 0x40) == 0) {
				if (g_game.carlos_direction == 0) {
					nicky_pos_x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2 + 32;
					nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_2 + g_game.player_state.dim_h;
					offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y);
					g_game.player_state.decor_ref_flag0 = 0;
					game_set_decor_tile_flag0(1, offset);
					if ((g_game.player_state.decor_ref_flag0 & 1) == 0) {
						goto loc_2C4B;
					}
					--offset;
					game_set_decor_tile_flag0(4, offset);
					if ((g_game.player_state.decor_ref_flag0 & 4) != 0) {
						goto loc_2C4B;
					}
				}
				if (g_game.carlos_direction < 0) {
					goto loc_2C4B;
				}
				g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[35];
				g_game.player_state.anim_frames_count = 2;
				g_game.player_state.hdir_flags |= 0x40;
				if (g_game.carlos_move_offsets_ptr != (const uint16_t *)&move_data[0]) {
					g_game.carlos_move_offsets_ptr = (const uint16_t *)&move_data[1];
				}
			}
		} else {
loc_2C4B:
			if (inp_direction_mask & GAME_DIR_RIGHT) {
				goto loc_2D03;
			}
			g_game.player_state.hdir_flags &= ~0x40;
			g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[19];
		}
	} else {
		if (inp_direction_mask & GAME_DIR_DOWN) {
			/* accroupi droite */
			if ((g_game.player_state.hdir_flags & 0x40) == 0) {
				if (g_game.carlos_direction == 0) {
					nicky_pos_x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2 + 16;
					nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_2 + g_game.player_state.dim_h;
					offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y);
					g_game.player_state.decor_ref_flag0 = 0;
					game_set_decor_tile_flag0(1, offset);
					if ((g_game.player_state.decor_ref_flag0 & 1) == 0) {
						goto loc_2CEC;
					}
					--offset;
					game_set_decor_tile_flag0(8, offset);
					if ((g_game.player_state.decor_ref_flag0 & 8) != 0) {
						goto loc_2CEC;
					}
				}
				if (g_game.carlos_direction == 1) {
					goto loc_2CEC;
				}
				g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[38];
				g_game.player_state.anim_frames_count = 2;
				g_game.player_state.hdir_flags |= 0x40;
				if (g_game.carlos_move_offsets_ptr != (const uint16_t *)&move_data[1]) {
					g_game.carlos_move_offsets_ptr = (const uint16_t *)&move_data[1];
				}
			}
		} else {
loc_2CEC:
			if (inp_direction_mask & GAME_DIR_LEFT) {
				goto loc_2D03;
			}
			g_game.player_state.hdir_flags &= ~0x40;
			g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[22];
		}
	}
//loc_2CFC:
	game_set_next_carlos_anim_frame();
	g_game.player_state.hdir_flags &= 0xC1;
loc_2D03:
	g_game.player_state.unk1 = 0;
	g_game.player_state.hdir_flags &= ~4;
	if (g_game.moving_decor_flag == 0) {
		g_game.player_state.vdir_flags |= 2;
	} else {
		if (inp_direction_mask & GAME_DIR_UP) {
			if (g_game.player_state.vdir_flags == 0) {
				g_game.player_state.move_offsets_data_ptr = g_game.carlos_move_offsets_ptr;
				g_game.player_state.unk1 = 2;
				g_game.player_state.vdir_flags |= 2;
				if (g_game.carlos_move_offsets_ptr == (const uint16_t *)&move_data[1]) {
					g_game.carlos_move_offsets_ptr = (const uint16_t *)&move_data[4];
				}
			}
		} else {
			g_game.player_state.vdir_flags = 0;
		}
	}
}

static void game_update_carlos_object_helper_right() {
	int nicky_pos_x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2 + 24;
	int nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_2 + g_game.player_state.dim_h - 2;
	int offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y);
	if (game_get_decor_tile_flag7(offset) == 0) {
		--offset;
		if (game_get_decor_tile_flag7(offset) == 0) {
			nicky_pos_x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2 + g_game.player_state.dim_w + 16;
			nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_1 + g_game.player_state.pos_dy_2;
			offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y);
			g_game.player_state.decor_ref_flag0 = 0;
			if (nicky_pos_y > _screen_h) {
				return;
			}
			game_set_decor_tile_flags4_3_2_0(4, offset);
			if ((g_game.player_state.decor_ref_flag0 & 4) == 0) {
				nicky_pos_x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2 + 40;
				nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_1 + g_game.player_state.pos_dy_2 - 16;
				offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y);
				game_set_decor_tile_flag0(4, offset);
				if ((g_game.player_state.decor_ref_flag0 & 4) != 0) {
					g_game.player_state.decor_ref_flag0 = 0;
					++offset;
					game_set_decor_tile_flag0(4, offset);
					if ((g_game.player_state.decor_ref_flag0 & 4) != 0) {
						goto loc_2539;
					}
				}
				nicky_pos_x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2 + 32;
				nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_1 + g_game.player_state.pos_dy_2 - 32 + 1;
				offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y);
				game_set_decor_tile_flag0(4, offset);
				if ((g_game.player_state.decor_ref_flag0 & 4) == 0) {
					if (g_game.player_state.pos_x < 280) {
						g_game.player_state.pos_x += GAME_ANIM_NICKY_DX;
					}
				}
			}
		} else {
			if ((g_game.player_state.hdir_flags & 8) == 0) {
				g_game.carlos_direction = 3;
				g_game.player_state.pos_y -= GAME_ANIM_NICKY_DY;
				if (g_game.player_state.pos_x < 280) {
					g_game.player_state.pos_x += GAME_ANIM_NICKY_DX;
				}
			}
		}
	} else {
		if ((g_game.player_state.hdir_flags & 8) == 0) {
			g_game.carlos_direction = 3;
			g_game.player_state.pos_y -= GAME_ANIM_NICKY_DY;
			if (g_game.player_state.pos_x < 280) {
				g_game.player_state.pos_x += GAME_ANIM_NICKY_DX;
			}
		}
	}
loc_2539:
	if ((g_game.player_state.hdir_flags & 1) == 0) {
		if (g_game.player_state.hdir_flags <= 7) {
			g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[17];
			g_game.player_state.hdir_flags |= 9;
			g_game.player_state.hdir_flags &= 0xBD;
			g_game.player_state.anim_frames_count = 2;
		}
	} else {
		if ((g_game.player_state.hdir_flags & 0xC) == 0) {
			if (g_game.player_state.hdir_flags <= 0xF || (inp_direction_mask & GAME_DIR_VERT) == 0) {
				if ((g_game.player_state.hdir_flags & 2) == 0) {
					g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[0];
					g_game.player_state.hdir_flags |= 2;
					g_game.player_state.hdir_flags &= 0x8F;
					g_game.player_state.anim_frames_count = 2;
				}
				game_set_next_carlos_anim_frame();
			}
		}
	}
}

static void game_update_carlos_object_helper_left() {
	int nicky_pos_x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2 + 22;
	int nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_2 + g_game.player_state.dim_h - GAME_ANIM_NICKY_DY;
	int offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y);
	if (game_get_decor_tile_flag7(offset) == 0) {
		++offset;
		if (game_get_decor_tile_flag7(offset) == 0) {
			nicky_pos_x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2 + 16;
			nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_1 + g_game.player_state.pos_dy_2;
			offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y);
			g_game.player_state.decor_ref_flag0 = 0;
			if (nicky_pos_y > _screen_h) {
				return;
			}
			game_set_decor_tile_flags4_3_2_0(8, offset);
			if ((g_game.player_state.decor_ref_flag0 & 8) == 0) {
				nicky_pos_x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2 + 8;
				nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_1 + g_game.player_state.pos_dy_2 - 16;
				offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y);
				game_set_decor_tile_flag0(8, offset);
				if ((g_game.player_state.decor_ref_flag0 & 8) != 0) {
					g_game.player_state.decor_ref_flag0 = 0;
					++offset;
					game_set_decor_tile_flag0(8, offset);
					if ((g_game.player_state.decor_ref_flag0 & 8) != 0) {
						goto loc_2781;
					}
				}
				nicky_pos_x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2 + 16;
				nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_1 + g_game.player_state.pos_dy_2 - 32 + 1;
				offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y);
				game_set_decor_tile_flag0(8, offset);
				if ((g_game.player_state.decor_ref_flag0 & 8) == 0) {
					if (g_game.player_state.pos_x > 8) {
						g_game.player_state.pos_x -= GAME_ANIM_NICKY_DX;
					}
				}
			}
		} else {
			if ((g_game.player_state.hdir_flags & 8) == 0) {
				g_game.carlos_direction = 1;
				g_game.player_state.pos_y += GAME_ANIM_NICKY_DY;
				if (g_game.player_state.pos_x > 8) {
					g_game.player_state.pos_x -= GAME_ANIM_NICKY_DX;
				}
			}
		}
	} else {
		if ((g_game.player_state.hdir_flags & 8) == 0) {
			g_game.carlos_direction = -1;
			g_game.player_state.pos_y -= GAME_ANIM_NICKY_DY;
			if (g_game.player_state.pos_x > 8) {
				g_game.player_state.pos_x -= GAME_ANIM_NICKY_DX;
			}
		}
	}
loc_2781:
	if (g_game.player_state.hdir_flags & 1) {
		if (g_game.player_state.hdir_flags <= 7) {
			g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[20];
			g_game.player_state.hdir_flags |= 8;
			g_game.player_state.hdir_flags &= 0xBC;
			g_game.player_state.anim_frames_count = 2;
		}
	} else {
		if ((g_game.player_state.hdir_flags & 0x8C) == 0) {
			if (g_game.player_state.hdir_flags <= 0xF || (inp_direction_mask & GAME_DIR_VERT) == 0) {
				if ((g_game.player_state.hdir_flags & 2) == 0) {
					g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[8];
					g_game.player_state.hdir_flags |= 2;
					g_game.player_state.hdir_flags &= 0x8F;
					g_game.player_state.anim_frames_count = 2;
				}
				game_set_next_carlos_anim_frame();
			}
		}
	}
}

static void game_update_carlos_object_helper_down() {
	if (g_game.moving_decor_flag != 0) {
		game_set_next_carlos_anim_frame();
		return;
	}
	int offset, nicky_pos_x, nicky_pos_y;
	nicky_pos_x = g_game.player_state.pos_x + 16 + g_game.player_state.pos_dx_2;
	nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.dim_h + g_game.player_state.pos_dy_2;
	if (nicky_pos_y > _screen_h) {
		return;
	}
	offset = game_get_nicky_offset(nicky_pos_x + 4, nicky_pos_y);
	g_game.player_state.decor_ref_flag0 = 0;
	g_game.player_state.decor_ref_flag3 = 0;
	game_set_decor_tile_flags4_3_2_0(1, offset);
	offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y);
	game_set_decor_tile_flags4_3_2_0(1, offset);
	if (g_game.player_state.decor_ref_flag3 < 1) {
		if (g_game.player_state.decor_ref_flag3 == 0) {
			g_game.player_state.hdir_flags &= ~0x30;
		}
		return;
	}
	if (g_game.player_state.pos_y <= _screen_h + 1) {
		g_game.player_state.pos_y += GAME_ANIM_NICKY_DY;
	}
	/* using stairs (going down) */
	if ((g_game.player_state.hdir_flags & 0x20) == 0) {
		g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[31];
		g_game.player_state.hdir_flags |= 0x20;
		g_game.player_state.hdir_flags &= 0xA1;
		g_game.player_state.unk1 = 0;
		g_game.player_state.anim_frames_count = 2;
	}
	game_set_next_carlos_anim_frame();
}

static void game_update_carlos_object_helper_up() {
	int offset, nicky_pos_x, nicky_pos_y;
	nicky_pos_x = g_game.player_state.pos_x + 16 + g_game.player_state.pos_dx_2;
	nicky_pos_y = g_game.player_state.pos_y + g_game.player_state.pos_dy_1 + g_game.player_state.pos_dy_2;
	if (nicky_pos_y > 0 && nicky_pos_y <= _screen_h) {
		offset = game_get_nicky_offset(nicky_pos_x + 4, nicky_pos_y);
		g_game.player_state.decor_ref_flag0 = 0;
		g_game.player_state.decor_ref_flag3 = 0;
		game_set_decor_tile_flags4_3_2_0(2, offset);
		offset = game_get_nicky_offset(nicky_pos_x + g_game.player_state.pos_dx_1, nicky_pos_y);
		game_set_decor_tile_flags4_3_2_0(2, offset);
		if (g_game.player_state.decor_ref_flag0 & 2) {
			g_game.player_state.hdir_flags &= ~0x30;
			return;
		}
		if (g_game.player_state.decor_ref_flag3 < 1) {
			if (g_game.player_state.decor_ref_flag3 == 0) {
				goto loc_2303;
			}
			g_game.player_state.hdir_flags &= ~0x30;
			return;
		}
		if (g_game.player_state.pos_y > 0) {
			offset = game_get_nicky_offset(nicky_pos_x, nicky_pos_y + 4);
			g_game.player_state.decor_ref_flag0 = 0;
			game_set_decor_tile_flags4_3_2_0(2, offset);
			if (g_game.player_state.decor_ref_flag0 & 2) {
				g_game.player_state.hdir_flags &= ~0x30;
				return;
			}
			g_game.player_state.pos_y -= GAME_ANIM_NICKY_DY;
		}
		/* using stairs (going up) */
		if ((g_game.player_state.hdir_flags & 0x10) == 0) {
			g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[27];
			g_game.player_state.hdir_flags |= 0x10;
			g_game.player_state.hdir_flags &= 0x91;
			g_game.player_state.anim_frames_count = 2;
		}
		game_set_next_carlos_anim_frame();
		return;
	}
loc_2303:
	/* jumping */
	g_game.player_state.hdir_flags &= ~0x30;
	if (g_game.player_state.vdir_flags == 0 && g_game.player_state.unk1 == 0) {
		g_game.player_state.unk1 = 2;
		g_game.player_state.move_offsets_data_ptr = g_game.carlos_move_offsets_ptr;
		if (g_game.player_state.move_offsets_data_ptr == (const uint16_t *)&move_data[1]) {
			g_game.player_state.move_offsets_data_ptr = (const uint16_t *)&move_data[4];
		}
	}
}

static void game_update_carlos_object_helper_down_right() {
	const int x = g_game.player_state.pos_x + g_game.player_state.dim_w + g_game.player_state.pos_dx_2 + 16;
	const int y = g_game.player_state.pos_y + g_game.player_state.pos_dy_1 + g_game.player_state.pos_dy_2;
	if (y <= _screen_h) {
		int offset = game_get_nicky_offset(x, y);
		g_game.player_state.decor_ref_flag0 = 0;
		game_set_decor_tile_flags4_3_2_0(4, offset);
		if ((g_game.player_state.decor_ref_flag0 & 4) == 0) {
			game_set_decor_tile_flag0(4, offset - 1);
			if ((g_game.player_state.decor_ref_flag0 & 4) == 0) {
				game_set_decor_tile_flag0(4, offset - 2);
				if ((g_game.player_state.decor_ref_flag0 & 4) == 0) {
					game_set_decor_tile_flag0(4, offset - 2 - _screen_cdg_tile_map_h);
					if ((g_game.player_state.decor_ref_flag0 & 4) != 0) {
						if (g_game.player_state.pos_x < _screen_w - 40) {
							g_game.player_state.pos_x += 2;
							inp_direction_mask |= GAME_DIR_DOWN;
							g_game.nicky_anim_flags1 = 0xFFFF;
						}
					}
				}
			}
		}
	}
}

static void game_update_carlos_object_helper_down_left() {
	const int x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2 + 16;
	const int y = g_game.player_state.pos_y + g_game.player_state.pos_dy_1 + g_game.player_state.pos_dy_2;
	if (y <= _screen_h) {
		int offset = game_get_nicky_offset(x, y);
		g_game.player_state.decor_ref_flag0 = 0;
		game_set_decor_tile_flags4_3_2_0(8, offset);
		if ((g_game.player_state.decor_ref_flag0 & 8) == 0) {
			game_set_decor_tile_flag0(8, offset - 1);
			if ((g_game.player_state.decor_ref_flag0 & 8) == 0) {
				game_set_decor_tile_flag0(8, offset - 2);
				if ((g_game.player_state.decor_ref_flag0 & 8) == 0) {
					game_set_decor_tile_flag0(8, offset - 2 + _screen_cdg_tile_map_h);
					if ((g_game.player_state.decor_ref_flag0 & 8) != 0) {
						if (g_game.player_state.pos_x > 16) {
							g_game.player_state.pos_x -= 2;
							inp_direction_mask |= GAME_DIR_DOWN;
							g_game.nicky_anim_flags1 = 0xFFFF;
						}
					}
				}
			}
		}
	}
}

static void game_update_anim_carlos_bullmode_default() {
	int x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2 + 16;
	int y = g_game.player_state.pos_y + g_game.player_state.pos_dy_2;
	if (y > 0) {
		y += g_game.player_state.dim_h;
		if (y < _screen_h + 8) {
			int offset = game_get_nicky_offset(x, y);
			game_set_decor_tile_flags4_3_2_0(1, offset);
		}
	}
	if (g_game.carlos_bullmode_flag == 2) {
		if ((inp_direction_mask & GAME_DIR_HORIZ) == 0) {
			if ((g_game.player_state.hdir_flags & 2) != 0) {
				if ((g_game.player_state.hdir_flags & 1) == 0) {
					g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[70];
				} else {
					g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[54];
				}
				g_game.player_state.anim_frames_count = 2;
				g_game.player_state.hdir_flags &= 0xFD;
			}
		}
	}
	game_set_next_carlos_anim_frame();
}

static void game_update_anim_carlos_bullmode_right() {
	if (g_game.carlos_bullmode_flag == 2) {
		const int x = g_game.player_state.pos_x + 48 + g_game.player_state.pos_dx_2;
		const int y = g_game.player_state.pos_y + g_game.player_state.dim_h + g_game.player_state.pos_dy_2;
		g_game.player_state.decor_ref_flag0 = 0;
		if (y <= _screen_h) {
			int offset = game_get_nicky_offset(x, y);
			game_set_decor_tile_flags4_3_2_0(1, offset);
			if ((g_game.player_state.decor_ref_flag0 & 1) != 0) {
				game_set_decor_tile_flags4_3_2_0(4, offset - 1);
				if ((g_game.player_state.decor_ref_flag0 & 4) == 0) {
					game_set_decor_tile_flags4_3_2_0(4, offset - 2);
					if ((g_game.player_state.decor_ref_flag0 & 4) == 0) {
						if (g_game.player_state.pos_x < _screen_w - 48) {
							g_game.player_state.pos_x += 2;
						}
					}
				}
				if ((g_game.player_state.hdir_flags & 1) != 0) {
					if ((g_game.player_state.hdir_flags & 2) == 0) {
						g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[57];
						g_game.player_state.hdir_flags |= 2;
						g_game.player_state.hdir_flags &= 0x8F;
						g_game.player_state.anim_frames_count = 2;
					}
					return;
				}
			} else {
				g_game.player_state.hdir_flags &= 0xFD;
			}
			g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[54];
			g_game.player_state.hdir_flags |= 1;
			g_game.player_state.hdir_flags &= 0xBD;
			g_game.player_state.anim_frames_count = 2;
		}
	}
}

static void game_update_anim_carlos_bullmode_left() {
	if (g_game.carlos_bullmode_flag == 2) {
		const int x = g_game.player_state.pos_x + g_game.player_state.pos_dx_2;
		const int y = g_game.player_state.pos_y + g_game.player_state.dim_h + g_game.player_state.pos_dy_2;
		g_game.player_state.decor_ref_flag0 = 0;
		if (y <= _screen_h) {
			int offset = game_get_nicky_offset(x, y);
			game_set_decor_tile_flags4_3_2_0(1, offset);
			if ((g_game.player_state.decor_ref_flag0 & 1) != 0) {
				game_set_decor_tile_flags4_3_2_0(8, offset - 1);
				if ((g_game.player_state.decor_ref_flag0 & 8) == 0) {
					game_set_decor_tile_flags4_3_2_0(4, offset - 2);
					if ((g_game.player_state.decor_ref_flag0 & 8) == 0) {
						if (g_game.player_state.pos_x >= 16) {
							g_game.player_state.pos_x -= 2;
						}
					}
				}
				if ((g_game.player_state.hdir_flags & 1) == 0) {
					if ((g_game.player_state.hdir_flags & 0x8C) != 0) {
						return;
					}
					if (g_game.player_state.hdir_flags > 0xF && (inp_direction_mask & GAME_DIR_VERT) != 0) {
						return;
					}
					if ((g_game.player_state.hdir_flags & 2) == 0) {
						g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[73];
						g_game.player_state.hdir_flags |= 2;
						g_game.player_state.hdir_flags &= 0x8F;
						g_game.player_state.anim_frames_count = 2;
					}
					return;
				}
			} else {
				g_game.player_state.hdir_flags &= 0xFD;
			}
			g_game.player_state.anim_frame_ptr = &carlos_anim_frames_table__v3[70];
			g_game.player_state.hdir_flags &= 0xBC;
			g_game.player_state.anim_frames_count = 2;
		}
	}
}

void game_update_anim_helper() {
	assert((inp_direction_mask & GAME_DIR_VERT) != GAME_DIR_VERT && (inp_direction_mask & GAME_DIR_HORIZ) != GAME_DIR_HORIZ);
	if (g_game.carlos_bullmode_flag) {
		if (inp_direction_mask & GAME_DIR_UP) {
			g_game.player_state.bullmode_duration = 1;
		}
		if (inp_direction_mask & GAME_DIR_RIGHT) {
			game_update_anim_carlos_bullmode_right();
		}
		if (inp_direction_mask & GAME_DIR_LEFT) {
			game_update_anim_carlos_bullmode_left();
		}
		game_update_anim_carlos_bullmode_default();
	} else {
		if (inp_direction_mask & GAME_DIR_UP) {
			game_update_carlos_object_helper_up();
		}
		if (inp_direction_mask & GAME_DIR_DOWN) {
			game_update_carlos_object_helper_down();
		}
		if (inp_direction_mask & GAME_DIR_RIGHT) {
			if (inp_direction_mask & GAME_DIR_DOWN) {
				game_update_carlos_object_helper_down_right();
			} else {
				game_update_carlos_object_helper_right();
			}
		}
		if (inp_direction_mask & GAME_DIR_LEFT) {
			if (inp_direction_mask & GAME_DIR_DOWN) {
				game_update_carlos_object_helper_down_left();
			} else {
				game_update_carlos_object_helper_left();
			}
		}
		game_update_carlos_object_helper_default();
	}
}
