
#ifndef FILEIO_H__
#define FILEIO_H__

#include "util.h"

typedef enum {
	FIO_READ = 0,
	FIO_WRITE
} fio_open_mode_e;

extern void	fio_init(const char *data_path);
extern int	fio_open(const char *filename, fio_open_mode_e mode, int error_flag);
extern void	fio_close(int slot);
extern int	fio_size(int slot);
extern const uint8_t *	fio_fetch(int slot);
extern int	fio_read(int slot, void *data, int len);
extern int	fio_write(int slot, void *data, int len);
extern int	fio_exists(const char *filename);

#endif // FILEIO_H__
