
#ifndef GLOBALS_H__
#define GLOBALS_H__

#include "util.h"
#include "intern.h"

#ifdef VARDECL
#define VARDEF
#else
#define VARDEF extern
#endif

VARDEF options_t g_options;

// game.c
VARDEF int _screen_tile_origin_x, _screen_tile_origin_y;
VARDEF int _screen_tile_map_offs_x, _screen_tile_map_offs_y, _screen_tile_map_offs_x_shl4, _screen_tile_map_offs_y_shl4;
VARDEF int _screen_cdg_tile_map_start_x, _screen_cdg_tile_map_start_y, _screen_cdg_tile_map_w, _screen_cdg_tile_map_h, _screen_cdg_tile_map_h2;
VARDEF int _screen_cdg_unk2;
VARDEF tile_anim_t _screen_blinking_tile[4];
VARDEF uint8_t _screen_cdg_offsets[256] GCC_EXT;
VARDEF const uint8_t *_screen_voffsets;
VARDEF int _screen_w, _screen_h;
VARDEF int8_t _snd_current_sfx_num, _snd_current_sfx_priority;

// input.c
VARDEF uint8_t inp_direction_mask;
VARDEF uint8_t inp_released_direction_mask;
VARDEF uint8_t inp_fire_button;
VARDEF uint8_t inp_key_pressed_action;
VARDEF uint8_t inp_key_pressed_quit;
VARDEF uint8_t inp_key_pressed_f[5];

// staticres.c
extern const anim_frame_t carlos_anim_frames_table__v3[77];
extern const uint16_t move_offsets_table5[30];
extern const uint8_t move_delta_table[1104];
extern const int16_t move_data[26];
extern const uint16_t DEGRA00_COP[160];
extern const uint16_t DEGRA01_COP[160];
extern const uint16_t DEGRA03_COP[160];
extern const uint16_t DEGRA04_COP[160];
extern const uint16_t DEGRA50_COP[160];
extern const uint8_t SAMPLES_SND[26 * 16];
extern const uint8_t DIGITS_SPR[380];
extern const uint8_t LIFEBAR_SPR[9102];
extern const uint16_t rotation_table__v3[768];

#endif // GLOBALS_H__
