
#include "game.h"
#include "globals.h"
#include "sound.h"

static void game_logic_op_helper6(object_state_t *os, anim_data_t *ad) {
	game_init_object_from_anim_data(os, ad);
	game_set_object_to_initial_pos(os, ad);
}

static anim_data_t *game_logic_op1(object_state_t *os, anim_data_t *ad) {
	int x = os->pos_x;
	if (os->unk2C != 0 && os->distance_pos_x != 0) {
		os->unk2E = os->unk2C + os->distance_pos_x;
		if (os->unk2E < 0) {
			x -= 8;
		} else {
			x += ad->anim_w;
		}
		const int offset = game_get_decor_offset(x, os->pos_y + ad->anim_h);
		const int a = g_res._decor_cdg[offset - 1] * 8;
		const int b = g_res._decor_cdg[offset] * 8;
		if ((g_res._decor_ref[b] & 1) != 0 && (g_res._decor_ref[a] & 12) == 0) {
			return game_reset_object_to_anim_pos(os, ad);
		}
		os->unk2E = 0;
	} else {
		if ((ad->unk6 & 2) == 0) {
			x -= 2;
		} else {
			x += ad->anim_w;
		}
		const int offset = game_get_decor_offset(x, os->pos_y + ad->anim_h);
		const int a = g_res._decor_cdg[offset - 1] * 8;
		const int b = g_res._decor_cdg[offset] * 8;
		if ((g_res._decor_ref[b] & 1) != 0 && (g_res._decor_ref[a] & 12) == 0) {
			if ((ad->unk6 & 0x80) == 0) {
				return game_reset_object_to_anim_pos(os, ad);
			}
			if (!ad->anim_data1_ptr) {
				os->displayed = 0;
			} else {
				ad = ad->anim_data1_ptr;
				game_logic_op_helper6(os, ad);
			}
			return ad;
		}
		game_logic_op_helper6(os, os->anim_data4_ptr);
	}
	return ad;
}

static void game_reset_object_to_initial_pos(object_state_t *os, anim_data_t *ad) {
	os->unk2C = 0;
	if (ad->cycles != 0 && --os->anim_data_cycles == 0) {
		anim_data_t *_si = ad->anim_data1_ptr;
		if (_si == &g_res._ref_ref_use_ptr3) {
			_si = os->anim_data3_ptr;
		}
		if (_si == 0) {
			os->displayed = 0;
		} else {
			os->anim_data1_ptr = _si;
			os->anim_data_cycles = _si->cycles;
			game_set_object_to_initial_pos(os, _si);
		}
	} else {
		game_set_object_to_initial_pos(os, ad);
	}
}

static anim_data_t *game_logic_op_helper7(object_state_t *os, anim_data_t *ad) {
	int x = os->pos_x - 2;
	if (os->distance_pos_x != 0) {
		if (os->distance_pos_x > 0) {
			x += ad->anim_w + 4;
		}
		int offs = game_get_decor_offset(x, os->pos_y);
		int _al = g_res._decor_cdg[offs];
		if (g_res._decor_ref[_al * 8] & 1) {
			os->distance_pos_x = 0;
		} else {
			offs = game_get_decor_offset(x, os->pos_y + ad->anim_h);
			_al = g_res._decor_cdg[offs];
			if (g_res._decor_ref[_al * 8] & 1) {
				os->distance_pos_x = 0;
			}
		}
	}
	int y = os->pos_y - 2;
	if (os->distance_pos_y != 0) {
		if (os->distance_pos_y > 0) {
			y += ad->anim_h + 4;
		}
		int offs = game_get_decor_offset(os->pos_x, y);
		int _al = g_res._decor_cdg[offs];
		if (g_res._decor_ref[_al * 8] & 1) {
			os->distance_pos_y = 0;
		} else {
			offs = game_get_decor_offset(os->pos_x + ad->anim_w, y);
			_al = g_res._decor_cdg[offs];
			if (g_res._decor_ref[_al * 8] & 1) {
				os->distance_pos_y = 0;
			}
		}
	}
	game_reset_object_to_initial_pos(os, ad);
	return ad;
}

static void game_logic_op_helper4(object_state_t *os, anim_data_t *ad) {
	os->anim_data1_ptr = ad;
	os->anim_data3_ptr = ad;
	os->anim_data4_ptr = ad->anim_data2_ptr;
	os->distance_pos_x = ad->distance_dx;
	os->distance_pos_y = ad->distance_dy;
	os->move_data_ptr = &ad->move_data_ptr[ad->init_sprite_num];
	os->displayed = ad->unk0;
	os->life = ad->lifes;
	os->anim_data_cycles = ad->cycles;
	os->unk3 = ad->unk3;
	os->displayed = 2;
	os->unk26 = ad->unk4;
	os->unk27 = ad->unk5;
	game_update_object_tilemap(os);
}

static anim_data_t *game_logic_op_helper5(object_state_t *os, anim_data_t *ad) {
	--g_game.game_state.boss_explosion_counter;
	if (g_game.game_state.boss_explosion_counter <= 0) {
		g_game.game_state.boss_explosion_counter = get_random_number(5) + 1;
		for (int i = 0; i < 9; ++i) {
			object_state_t *_bx = &os[i + 1];
			if (_bx->displayed != 2) {
				if (ad->anim_data3_ptr) {
					anim_data_t *_dx = ad->anim_data3_ptr;
					_bx->pos_x = os->pos_x + get_random_number(ad->anim_w) - 10;
					_bx->pos_y = os->pos_y + get_random_number(ad->anim_h) - 10;
					_bx->anim_data1_ptr = _dx;
					_bx->anim_data3_ptr = _dx;
					_bx->anim_data4_ptr = _dx->anim_data2_ptr;
					_bx->distance_pos_x = _dx->distance_dx;
					_bx->distance_pos_y = _dx->distance_dy;
					_bx->move_data_ptr = _dx->move_data_ptr;
					_bx->displayed = _dx->unk0;
					_bx->life = _dx->lifes;
					_bx->anim_data_cycles = _dx->cycles;
					_bx->unk3 = _dx->unk3;
					_bx->displayed = 2;
					_bx->unk26 = _dx->unk4;
					_bx->unk27 = _dx->unk5;
					_bx->transparent_flag = 0;
					if (_dx->sound_num >= 0) {
						snd_play_sfx(_dx->sound_num);
					}
				}
				if (g_game.game_state.boss_fight_counter < 60) {
					++g_game.game_state.boss_fight_counter;
					break;
				}
				os->displayed = 0;
				if (1) {
					ad = os->anim_data1_ptr; /* _si */
					anim_data_t *__bx = ad->anim_data4_ptr;
					if (!__bx) {
						warning("game_logic_op_helper5() ad->anim_data4_ptr is 0");
						break;
					}
					os->anim_data1_ptr = __bx;
					os->anim_data3_ptr = __bx;
					os->anim_data4_ptr = __bx->anim_data2_ptr;
					os->distance_pos_x = __bx->distance_dx;
					os->distance_pos_y = __bx->distance_dy;
					os->move_data_ptr = &__bx->move_data_ptr[__bx->init_sprite_num];
					os->displayed = __bx->unk0;
					os->life = __bx->lifes;
					os->anim_data_cycles = __bx->cycles;
					os->unk3 = __bx->unk3;
					os->displayed = 2;
					os->unk26 = __bx->unk4;
					os->unk27 = __bx->unk5;
					os->pos_y += ad->dy2;
					os->pos_x += ad->dx2;
					break;
				}
			}
		}
	}
	return ad;
}

static anim_data_t *game_logic_op0(object_state_t *os, anim_data_t *ad) {
	if (os->unk27 == 0 || --os->unk27 != 0) {
		ad = game_reset_object_to_anim_pos(os, ad);
	} else {
		if (os->anim_data4_ptr == 0) {
			os->displayed = 0;
		} else {
			ad = os->anim_data4_ptr;
			game_logic_op_helper6(os, ad);
		}
	}
	return ad;
}

anim_data_t *game_logic_op2(object_state_t *os, anim_data_t *ad) {
	int dy, offs;
	if (os->move_data_ptr[1] == 0x88) {
		os->displayed = 0;
	} else {
		uint8_t tile_num;
		int16_t _ax, _bx, _dx;
		dy = (int8_t)os->move_data_ptr[1];
		os->move_data_ptr += 2;
		os->pos_y += dy - g_game.decor_state.delta_y;
		_bx = os->pos_y;
		_dx = ad->anim_h / 2;
		if (dy >= 0) {
			_bx += ad->anim_h;
			_dx = -_dx;
		}
		_ax = os->distance_pos_x;
		if (_ax != 0) {
			if (_ax > 0) {
				_ax += ad->bounding_box_x2;
			}
			offs = game_get_decor_offset(_ax + os->pos_x, _bx + _dx + g_game.decor_state.delta_y);
			tile_num = g_res._decor_cdg[offs];
			if (g_res._decor_ref[tile_num * 8] & 1) {
				os->distance_pos_x = 0;
			}
		}
		os->pos_x += os->distance_pos_x - g_game.decor_state.delta_x;
		offs = game_get_decor_offset(os->pos_x + g_game.decor_state.delta_x, _bx + g_game.decor_state.delta_y);
		tile_num = g_res._decor_cdg[offs];
		if ((g_res._decor_ref[tile_num * 8] & 1) == 0) {
			offs = game_get_decor_offset(os->pos_x + ad->bounding_box_x2 + g_game.decor_state.delta_x, _bx + g_game.decor_state.delta_y);
			tile_num = g_res._decor_cdg[offs];
			if ((g_res._decor_ref[tile_num * 8] & 0x10) == 0) {
				goto loc_7279;
			}
		}
		if (dy <= 0) {
			os->move_data_ptr = &ad->move_data_ptr[ad->init_sprite_num];
			goto loc_7279;
		}
		++os->unk27;
		if (os->unk27 < 4) {
			os->move_data_ptr = &ad->move_data_ptr[os->unk27 * 4];
		} else if (os->anim_data4_ptr == 0) {
			os->displayed = 0;
		} else {
			ad = os->anim_data4_ptr;
			os->anim_data1_ptr = ad;
			os->anim_data3_ptr = ad;
			os->anim_data4_ptr = ad->anim_data2_ptr;
			os->distance_pos_x = ad->distance_dx;
			os->move_data_ptr = ad->move_data_ptr;
			os->distance_pos_y = ad->distance_dy;
			os->anim_data_cycles = ad->cycles;
			os->unk3 = ad->unk3;
			os->unk26 = ad->unk4;
			os->unk27 = ad->unk5;
			_bx = (os->pos_y + g_game.decor_state.offs_y + ad->anim_h) & ~0xF;
			_bx -= ad->anim_h;
			_bx -= g_game.decor_state.offs_y;
			os->pos_y = _bx;
loc_7279:
			if (ad->cycles != 0 && --os->anim_data_cycles == 0) {
				anim_data_t *_si = ad->anim_data1_ptr;
				if (_si == &g_res._ref_ref_use_ptr3) {
					_si = os->anim_data3_ptr;
				}
				if (_si == 0) {
					os->displayed = 0;
					return ad;
				}
				ad = _si;
				os->anim_data1_ptr = ad;
				os->anim_data_cycles = ad->cycles;
			}
		}
	}
	return ad;
}

static anim_data_t *game_logic_op3(object_state_t *os, anim_data_t *ad) {
	int offs;
	uint8_t tile_num;

	offs = game_get_decor_offset(os->pos_x, os->pos_y + ad->anim_h);
	tile_num = g_res._decor_cdg[offs];
	if ((g_res._decor_ref[tile_num * 8] & 0x10) == 0) {
		anim_data_t *ad2 = os->anim_data4_ptr;
		if (ad2 == 0) {
			os->displayed = 0;
			return ad;
		}
		os->anim_data1_ptr = ad2;
		os->anim_data3_ptr = ad2;
		os->anim_data4_ptr = ad2->anim_data2_ptr;
		os->move_data_ptr = &ad2->move_data_ptr[ad->init_sprite_num];
		os->anim_data_cycles = ad2->cycles;
		os->unk3 = ad2->unk3;
		os->unk26 = ad2->unk4;
		os->unk27 = ad2->unk5;
		ad = ad2;
	}
	os->pos_x -= g_game.decor_state.delta_x;
	os->pos_y -= g_game.decor_state.delta_y;
	return ad;
}

static anim_data_t *game_logic_op4(object_state_t *os, anim_data_t *ad) {
	os->anim_data2_ptr = 0;
	++os->ref_ref_index;
	os->ref_ref_index &= 7;
	if (os->ref_ref_index == 0) {
		os->displayed = 0;
		return ad;
	}
	return game_logic_op0(os, ad);
}

static anim_data_t *game_logic_op5(object_state_t *os, anim_data_t *ad) {
	os->distance_pos_x = 0;
	os->distance_pos_y = 0;
	if (os->unk2C == 0) {
		os->distance_pos_x = 1 + g_game.cycle_counter;
		os->distance_pos_y = 1 + g_game.cycle_counter;
		const int y = g_game.player_state.pos_y + 32 - 8;
		if (os->pos_y >= y) {
			if (os->pos_y <= y - 4) {
				os->distance_pos_y = 0;
			} else {
				os->distance_pos_y = -os->distance_pos_y;
			}
		}
		const int x = g_game.player_state.pos_x + 16 - 8;
		if (os->pos_x >= x) {
			if (os->pos_x <= x + 4) {
				os->distance_pos_x = 0;
			} else {
				os->distance_pos_x = -os->distance_pos_x;
			}
		}
		return game_logic_op_helper7(os, ad);
	}
	game_reset_object_to_initial_pos(os, ad);
	return ad;
}

static anim_data_t *game_logic_op6_helper(object_state_t *os, anim_data_t *ad) {
	int dx = os->distance_pos_x;
	if (dx < 0) {
		dx = -dx;
	}
	int x = os->pos_x - dx;
	int fl = 8;
	if (os->distance_pos_x != 0) {
		if (os->distance_pos_x > 0) {
			x += ad->anim_w + dx * 2;
			fl = 4;
		}
		int offset = game_get_decor_offset(x, os->pos_y + ad->anim_h);
		int num = g_res._decor_cdg[offset];
		if ((g_res._decor_ref[num * 8] & 1) == 0) {
			os->distance_pos_x = 0;
			return ad;
		}
		--offset;
		num = g_res._decor_cdg[offset];
		if ((g_res._decor_ref[num * 8] & fl) != 0 || g_res._decor_ref[num * 8 + 7] != 0) {
			os->distance_pos_x = 0;
			return ad;
		}
		if (ad->anim_h > 16) {
			--offset;
			num = g_res._decor_cdg[offset];
			if ((g_res._decor_ref[num * 8] & fl) != 0 || g_res._decor_ref[num * 8 + 7] != 0) {
				os->distance_pos_x = 0;
				return ad;
			}
		}
	}
	if (os->unk2C == 0) {
		if (os->distance_pos_x == 0) {
			return ad;
		}
		if ((os->distance_pos_x < 0 && (ad->unk6 & 2) != 0) || (os->distance_pos_x > 0 && (ad->unk6 & 2) == 0)) {
			os->distance_pos_x = 0;
			anim_data_t *ad = os->anim_data4_ptr;
			game_init_object_from_anim_data(os, ad);
			game_play_anim_data_sfx(ad);
			return ad;
		}
	}
	os->unk2C = 0;
	if (ad->cycles != 0 && --os->anim_data_cycles == 0) {
		ad = ad->anim_data1_ptr;
		if (ad != 0 && (ad != &g_res._ref_ref_use_ptr3 || (ad = os->anim_data3_ptr) != 0)) {
			os->anim_data1_ptr = ad;
			os->anim_data_cycles = ad->cycles;
		} else {
			os->displayed = 0;
			return ad;
		}
	}
	game_set_object_to_initial_pos(os, ad);
	return ad;
}

static anim_data_t *game_logic_op6(object_state_t *os, anim_data_t *ad) {
	os->distance_pos_y = 0;
	os->distance_pos_x = os->unk2C;
	if (os->distance_pos_x == 0) {
		os->distance_pos_x = 1 + g_game.cycle_counter;
		int x = g_game.player_state.pos_x + 16 - 8;
		if (os->pos_x >= x) {
			if (os->pos_x < x + 4) {
				os->distance_pos_x = 0;
			} else {
				os->distance_pos_x = -os->distance_pos_x;
			}
		}
	}
	return game_logic_op6_helper(os, ad);
}

static anim_data_t *game_logic_op7(object_state_t *os, anim_data_t *ad) {
	if (os->move_data_ptr[1] == 0x88) {
		os->displayed = 0;
		return ad;
	}
	os->move_data_ptr += 2;
	int dy = (int8_t)os->move_data_ptr[1];
	os->pos_y += dy - g_game.decor_state.delta_y;
	os->pos_x += os->distance_pos_x;
	if (dy >= 0) {
		dy += ad->anim_h;
	}
	int offset = game_get_decor_offset(os->pos_x, os->pos_y + dy);
	int b = g_res._decor_cdg[offset] * 8;
	if ((g_res._decor_ref[b] & 1) == 0) {
		offset = game_get_decor_offset(os->pos_x + ad->bounding_box_x2, os->pos_y + dy);
		b = g_res._decor_cdg[offset] * 8;
		if ((g_res._decor_ref[b] & 1) == 0) {
			return ad;
		}
	}
	os->pos_y = ((os->pos_y + ad->anim_h) & ~15) - ad->anim_h;
	if (!os->anim_data4_ptr) {
		os->displayed = 0;
		return ad;
	}
	const int x = os->pos_x;
	const int y = os->pos_y;
	anim_data_t *ad2 = os->anim_data4_ptr;
	for (int i = 0; i < 2; ++i) {
		game_init_object_from_anim_data(&os[i], &ad2[i]);
		os[i].life = ad2[i].lifes;
		os[i].displayed = 2;
		os[i].pos_x = x;
		os[i].pos_y = y;
	}
	game_play_anim_data_sfx(os->anim_data1_ptr);
	return ad;
}

static anim_data_t *game_logic_op8(object_state_t *os, anim_data_t *ad) {
	ad = game_logic_op_helper5(os, ad);
	return game_logic_op0(os, ad);
}

static anim_data_t *game_logic_op10(object_state_t *os, anim_data_t *ad) {
	_snd_current_sfx_num = 20;
	game_shake_screen();
	g_game.player_state.colliding += 8;
	if (g_game.carlos_bullmode_flag == 0) {
		g_game.player_state.colliding += 4;
	}
	return game_logic_op0(os, ad);
}

static anim_data_t *game_logic_op11(object_state_t *os, anim_data_t *ad) {
	if (os->unk29 == 0) {
		os->ref_ref_index = (os->ref_ref_index & 0xFF00) | 8;
		const int offset = (os->map_pos_x >> 4) * _screen_cdg_tile_map_h + (os->map_pos_y >> 4);
		g_res._decor_cdg[offset] = 8;
		g_game.test_object_bounding_box_result = -1;
	}
	++os->unk29;
	if (os->unk29 >= os->tile_num) {
		os->unk29 = 0;
	}
	return ad;
}

static anim_data_t *game_logic_op12(object_state_t *os, anim_data_t *ad) {
	if (os->unk2C == 0) {
		--os->unk27;
		if (os->unk27 <= 0) {
			os->unk27 = get_random_number(15) + 8;
			os->distance_pos_x = get_random_number(5) - 2;
			os->distance_pos_y = get_random_number(5) - 2;
		}
	} else {
		os->distance_pos_x = 0;
		os->distance_pos_y = 0;
		os->unk27 = 0;
	}
	return game_logic_op_helper7(os, ad);
}

static anim_data_t *game_logic_op13(object_state_t *os, anim_data_t *ad) {
	os->distance_pos_x = os->unk2C;
	if (os->unk2C == 0) {
		if (--os->unk27 <= 0) {
			os->unk27 = get_random_number(15) + 8;
			os->distance_pos_x = get_random_number(5) - 2;
		}
	} else {
		os->distance_pos_y = 0;
		os->unk27 = 0;
	}
	return game_logic_op6_helper(os, ad);
}

static anim_data_t *game_logic_op16(object_state_t *os, anim_data_t *ad) {
	os->anim_data2_ptr = 0;
	os->displayed = 0;
	os[1].pos_x = os->pos_x;
	os[1].pos_y = os->pos_y;
	os[1].anim_data2_ptr = os->anim_data4_ptr;
	game_logic_op_helper4(os + 1, os->anim_data4_ptr);
	snd_play_sfx(SND_SAMPLE_17);
	game_set_object_to_initial_pos(os, ad);
	return ad;
}

static void game2_logic_op22_helper(object_state_t *os) {
	uint8_t _bl, _ax, _cx;
	os->distance_pos_x = 0;
	os->distance_pos_y = 0;
	if ((os->ref_ref_index & 0x8000) != 0 && (os->tile_num & 1) != 0) {
		os->tile_num &= ~1;
	}
	if ((os->tile_num & 0x80) == 0) {
		if ((os->ref_ref_index & 0x5000) == 0) {
			os->unk29 = (os->ref_ref_index * 4) & 0xF0;
		} else {
			os->unk29 = os->ref_ref_index & 0xF0;
		}
		os->tile_num = ((os->ref_ref_index >> 8) & 0x78) | 0x80;
	}
	_bl = ((os->ref_ref_index >> 8) & 7) + 1;
	if ((os->tile_num & 0x40) == 0 && (os->tile_num & 0x10) == 0) {
		os->unk29 += _bl;
		_cx = os->ref_ref_index & 0xFF;
		_ax = (((_cx >> 4) + _cx) & 0x1F) << 4;
		if (_ax != os->unk29) {
			if ((os->tile_num & 0x20) == 0) {
				os->distance_pos_x += _bl;
			} else {
				os->distance_pos_y += _bl;
			}
			return;
		}
	} else {
		os->unk29 -= _bl;
		if (os->unk29 != 0) {
			if ((os->tile_num & 0x40) == 0) {
				os->distance_pos_x -= _bl;
			} else {
				os->distance_pos_y -= _bl;
			}
			return;
		}
	}
	if (os->tile_num & 0x40) {
		os->tile_num = (os->tile_num & ~0x40) | 0x20;
	} else if (os->tile_num & 0x20) {
		os->tile_num = (os->tile_num & ~0x20) | 0x40;
	} else if (os->tile_num & 0x10) {
		os->tile_num = (os->tile_num & ~0x10) | 0x08;
	} else {
		os->tile_num = (os->tile_num & ~0x08) | 0x10;
	}
	os->tile_num |= 1;
}

anim_data_t *game_logic_op19(object_state_t *os, anim_data_t *ad) {
	if (os->unk2C == 0) {
		int x = os->pos_x;
		if (ad->unk6 & 2) {
			x += ad->anim_w;
		} else {
			x -= 2;
		}
		const int xoffset = ((x + g_game.decor_state.offs_x - g_game.decor_state.delta_x) >> 4) * _screen_cdg_tile_map_h + g_game.decor_state.tile_block_x;
		if (xoffset > _screen_cdg_tile_map_h) {
			int offset = game_get_decor_offset(x, os->pos_y + ad->anim_h);
			int b = g_res._decor_cdg[offset - 1] * 8;
			if ((g_res._decor_ref[b] & 1) == 0) {
				if ((ad->unk6 & 0x80) == 0) {
					return game_reset_object_to_anim_pos(os, ad);
				}
				if (!ad->anim_data1_ptr) {
					os->displayed = 0;
					return ad;
				}
				ad = ad->anim_data1_ptr;
			} else {
				ad = os->anim_data4_ptr;
			}
		} else {
			ad = os->anim_data4_ptr;
		}
		game_init_object_from_anim_data(os, ad);
		game_set_object_to_initial_pos(os, ad);
		return ad;
	}
	return game_reset_object_to_anim_pos(os, ad);
}

anim_data_t *game_logic_op21(object_state_t *os, anim_data_t *ad) {
	if (os->unk27 == 0 || --os->unk27 != 0) {
		ad = game_reset_object_to_anim_pos(os, ad);
	} else {
		ad = os->anim_data4_ptr;
		if (ad) {
			game_logic_op_helper6(os, ad);
		} else {
			os->displayed = 0;
		}
	}
	return ad;
}

anim_data_t *game_logic_op22(object_state_t *os, anim_data_t *ad) {
	game2_logic_op22_helper(os);
	return game_logic_op21(os, ad);
}

anim_data_t *game_logic_op23(object_state_t *os, anim_data_t *ad) {
	if (os->unk27 == 0 || --os->unk27 != 0) {
		const uint8_t *data = os->move_data_ptr;
		os->move_data_ptr = 0;
		ad = game_reset_object_to_anim_pos(os, ad);
		os->move_data_ptr = data;
	} else {
		ad = os->anim_data4_ptr;
		if (ad) {
			const uint8_t *data = os->move_data_ptr;
			os->move_data_ptr = 0;
			game_logic_op_helper6(os, ad);
			os->move_data_ptr = data;
		} else {
			os->displayed = 0;
		}
	}
	return ad;
}

anim_data_t *game_logic_op26(object_state_t *os, anim_data_t *ad) {
	os->anim_data2_ptr = 0;
	os->displayed = 0;
	os[1].pos_x = os->pos_x;
	os[1].pos_y = os->pos_y;
	anim_data_t *ad2 = os->anim_data4_ptr;
	os[1].anim_data2_ptr = ad2;
	game_init_object_from_anim_data(&os[1], ad2);
	os[1].move_data_ptr += ad2->init_sprite_num;
	os[1].life = ad2->lifes;
	os[1].displayed = 2;
	os[1].unk2C = 0;
	game_set_object_to_initial_pos(os, ad);
	return ad;
}

anim_data_t *game_logic_op(object_state_t *os, anim_data_t *ad) {
	switch (ad->logic_opcode) {
	case 0:
		ad = game_logic_op0(os, ad);
		break;
	case 1:
		ad = game_logic_op1(os, ad);
		break;
	case 2:
		ad = game_logic_op2(os, ad);
		break;
	case 3:
		ad = game_logic_op3(os, ad);
		break;
	case 4:
		ad = game_logic_op4(os, ad);
		break;
	case 5:
		ad = game_logic_op5(os, ad);
		break;
	case 6:
		ad = game_logic_op6(os, ad);
		break;
	case 7:
		ad = game_logic_op7(os, ad);
		break;
	case 8:
		ad = game_logic_op8(os, ad);
		break;
	case 10:
		ad = game_logic_op10(os, ad);
		break;
	case 11:
		ad = game_logic_op11(os, ad);
		break;
	case 12:
		ad = game_logic_op12(os, ad);
		break;
	case 13:
		ad = game_logic_op13(os, ad);
		break;
	case 16:
		ad = game_logic_op16(os, ad);
		break;
	case 19:
		ad = game_logic_op19(os, ad);
		break;
	case 21:
		ad = game_logic_op21(os, ad);
		break;
	case 22:
		ad = game_logic_op22(os, ad);
		break;
	case 23:
		ad = game_logic_op23(os, ad);
		break;
	case 25:
		// no-op
		break;
	case 26:
		ad = game_logic_op26(os, ad);
		break;
	default:
		warning("game_logic_op logic_opcode %d", ad->logic_opcode);
		break;
	}
	return ad;
}

