
#ifndef RESOURCE_H__
#define RESOURCE_H__

#include "util.h"
#include "intern.h"

#define REF_REF_SIZE 224
#define DECOR_CDG_SIZE 28800
#define DECOR_REF_SIZE 2048 /* 8 bytes per tile */
#define MAX_RES_SLOTS 8
#define RES_TXT_SIZE 2048

#define IMAGE_MICROIDS  0  /* I00 */
#define IMAGE_TITLE     1  /* I01 */
#define IMAGE_CREDITS   2  /* I02 */
#define IMAGE_LEVELS    20 /* I2x */

struct resource_t {
	uint8_t _decor_cdg[DECOR_CDG_SIZE];
	uint8_t _decor_ref[DECOR_REF_SIZE];
	anim_data_t _ref_ref[REF_REF_SIZE];
	anim_data_t _ref_ref_use_ptr3; /* (anim_data_t *)0xFFFF in the original code */
	anim_data_t anim_data0;
	const uint8_t *_decor_pal;
	const uint8_t *_copper_pal;
	const uint8_t *_decor_blk;
	int _level_spr;
	int _oscar_spr;
	int _friend_spr;
	const uint8_t *_posit_ref;
	int _posit_count;
	int _boss_spr;
	int _carlos1_spr;
	int _carlos2_spr;
	int _lifebar_spr;
	int _digits_spr;
	const uint8_t *_new_new;
	int slot_count;
	int slot_table[MAX_RES_SLOTS];
	bool level_data_loaded;
	bool converted_data;
	const char *gfx_ext;
	const char *dat_ext;
	int gfx_scale_w;
	int gfx_scale_h;
	int img;
};

extern struct resource_t g_res GCC_EXT;

extern void	res_detect();
extern const uint8_t *	res_get_new_ptr(int num);
extern void	res_load_level_data__v3(int level);
extern void	res_unload_level_data();
extern void	res_load_fond(int num, int level);
extern void	res_load_img(int num);
extern void	res_init_static_data__v3();

#endif // RESOURCE_H__
