
#include "decode.h"
#include "fileio.h"
#include "resource.h"
#include "systemstub.h"

int load_sprite(const char *name, int level, const uint16_t *pal)  {
	const uint8_t *data;
	int slot, spr;

	slot = fio_open(name, FIO_READ, 1);
	data = fio_fetch(slot);
	spr = sys_load_sprite_data(data, fio_size(slot), 0, 0);
	fio_close(slot);
	return spr;
}

int load_static_sprite(const uint8_t *data, const uint16_t *pal) {
	return -1;
}

void load_tile(const char *name, int level, const uint16_t *pal) {
	int slot;
	char filename[64];
	const uint8_t *data;

	snprintf(filename, sizeof(filename), "%s.LZ", name);
	slot = fio_open(filename, FIO_READ, 1);
	data = fio_fetch(slot);
	sys_set_tile_data(data, fio_size(slot), 0);
	fio_close(slot);
}

void load_fond(int num, int level, const uint16_t *pal) {
	int slot;
	char filename[32];
	const uint8_t *data;

	snprintf(filename, sizeof(filename), "FOND%02d.BG", num);
	slot = fio_open(filename, FIO_READ, 0);
	if (slot >= 0) {
		data = fio_fetch(slot);
		sys_set_background_frame(data, fio_size(slot));
		fio_close(slot);
	} else {
		sys_set_background_frame(0, 0);
	}
}

void res_load_img(int num) {
	int slot;
	char filename[32];
	const uint8_t *data;

	snprintf(filename, sizeof(filename), "I%02d.555", num);
	slot = fio_open(filename, FIO_READ, 0);
	if (slot >= 0) {
		sys_set_screen_mode(SSM_BITMAP);
		data = fio_fetch(slot);
		sys_set_bitmap_data(data, fio_size(slot));
		fio_close(slot);
		g_res.img = num;
	} else {
		sys_set_bitmap_data(0, 0);
		g_res.img = -1;
	}
}
