
#include "sound.h"
#include "systemstub.h"

static const uint8_t _lut[MAX_SND_SAMPLES] = {
	/* 0 */
	0,
	1,
	2,
	-1,
	/* 4 */
	3,
	4,
	5,
	6,
	/* 8 */
	7,
	-1,
	8,
	9,
	/* 12 */
	-1,
	10,
	-1,
	-1,
	/* 16 */
	11,
	-1,
	-1,
	-1,
	/* 20 */
	12,
	13,
	-1,
	-1,
	/* 24 */
	14,
	15
};

void snd_play_sfx(int num) {
	assert(num < MAX_SND_SAMPLES);
	num = _lut[num];
	if (num != -1) {
		sys_play_sfx(num, 0, 0);
	}
}

void snd_play_song(int num) {
	sys_play_module(num, 0, 0);
}

void snd_stop_song() {
	sys_stop_module();
}
